From cad9ff6c9e98431658d0797ae29c4ef004584357 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Sep 02 2020 04:18:17 +0000
Subject: [PATCH 799/2232] Cache computation of target directory


Previously we would be repeating at least 7 successive Cargo invocation.

---

diff --git a/gen/build/src/lib.rs b/gen/build/src/lib.rs
index 5c0f12a..eea9e68 100644
--- a/gen/build/src/lib.rs
+++ b/gen/build/src/lib.rs
@@ -62,6 +62,7 @@ mod syntax;
 use crate::error::Result;
 use crate::gen::error::report;
 use crate::gen::{fs, Opt};
+use crate::paths::TargetDir;
 use cc::Build;
 use std::io::{self, Write};
 use std::iter;
@@ -98,34 +99,39 @@ pub fn bridges(rust_source_files: impl IntoIterator<Item = impl AsRef<Path>>) ->
 }
 
 fn build(rust_source_files: &mut dyn Iterator<Item = impl AsRef<Path>>) -> Result<Build> {
-    let mut build = paths::cc_build();
+    let ref target_dir = paths::target_dir()?;
+    let mut build = paths::cc_build(target_dir);
     build.cpp(true);
     build.cpp_link_stdlib(None); // linked via link-cplusplus crate
-    write_header()?;
+    write_header(target_dir)?;
 
     for path in rust_source_files {
-        generate_bridge(&mut build, path.as_ref())?;
+        generate_bridge(&mut build, path.as_ref(), target_dir)?;
     }
 
     Ok(build)
 }
 
-fn write_header() -> Result<()> {
-    let ref cxx_h = paths::include_dir()?.join("rust").join("cxx.h");
+fn write_header(target_dir: &TargetDir) -> Result<()> {
+    let ref cxx_h = paths::include_dir(target_dir)?.join("rust").join("cxx.h");
     let _ = write(cxx_h, gen::include::HEADER.as_bytes());
     Ok(())
 }
 
-fn generate_bridge(build: &mut Build, rust_source_file: &Path) -> Result<()> {
+fn generate_bridge(
+    build: &mut Build,
+    rust_source_file: &Path,
+    target_dir: &TargetDir,
+) -> Result<()> {
     let opt = Opt::default();
     let generated = gen::generate_from_path(rust_source_file, &opt);
 
-    let header_path = paths::out_with_extension(rust_source_file, ".h")?;
+    let header_path = paths::out_with_extension(rust_source_file, ".h", target_dir)?;
     fs::create_dir_all(header_path.parent().unwrap())?;
     write(&header_path, &generated.header)?;
-    paths::symlink_header(&header_path, rust_source_file);
+    paths::symlink_header(&header_path, rust_source_file, target_dir);
 
-    let implementation_path = paths::out_with_extension(rust_source_file, ".cc")?;
+    let implementation_path = paths::out_with_extension(rust_source_file, ".cc", target_dir)?;
     write(&implementation_path, &generated.implementation)?;
     build.file(&implementation_path);
     Ok(())
diff --git a/gen/build/src/paths.rs b/gen/build/src/paths.rs
index e6b29bd..3f4814e 100644
--- a/gen/build/src/paths.rs
+++ b/gen/build/src/paths.rs
@@ -20,26 +20,26 @@ fn out_dir() -> Result<PathBuf> {
         .ok_or(Error::MissingOutDir)
 }
 
-pub(crate) fn cc_build() -> cc::Build {
-    try_cc_build().unwrap_or_default()
+pub(crate) fn cc_build(target_dir: &TargetDir) -> cc::Build {
+    try_cc_build(target_dir).unwrap_or_default()
 }
 
-fn try_cc_build() -> Result<cc::Build> {
+fn try_cc_build(target_dir: &TargetDir) -> Result<cc::Build> {
     let mut build = cc::Build::new();
-    build.include(include_dir()?);
-    build.include(target_dir()?.parent().unwrap());
+    build.include(include_dir(target_dir)?);
+    build.include(target_dir.parent().unwrap());
     Ok(build)
 }
 
 // Symlink the header file into a predictable place. The header generated from
 // path/to/mod.rs gets linked to targets/cxxbridge/path/to/mod.rs.h.
-pub(crate) fn symlink_header(path: &Path, original: &Path) {
-    let _ = try_symlink_header(path, original);
+pub(crate) fn symlink_header(path: &Path, original: &Path, target_dir: &TargetDir) {
+    let _ = try_symlink_header(path, original, target_dir);
 }
 
-fn try_symlink_header(path: &Path, original: &Path) -> Result<()> {
-    let suffix = relative_to_parent_of_target_dir(original)?;
-    let ref dst = include_dir()?.join(suffix);
+fn try_symlink_header(path: &Path, original: &Path, target_dir: &TargetDir) -> Result<()> {
+    let suffix = relative_to_parent_of_target_dir(original, target_dir)?;
+    let ref dst = include_dir(target_dir)?.join(suffix);
 
     fs::create_dir_all(dst.parent().unwrap())?;
     let _ = fs::remove_file(dst);
@@ -53,8 +53,7 @@ fn try_symlink_header(path: &Path, original: &Path) -> Result<()> {
     Ok(())
 }
 
-fn relative_to_parent_of_target_dir(original: &Path) -> Result<PathBuf> {
-    let target_dir = target_dir()?;
+fn relative_to_parent_of_target_dir(original: &Path, target_dir: &TargetDir) -> Result<PathBuf> {
     let mut outer = target_dir.parent().unwrap();
     let original = canonicalize(original)?;
     loop {
@@ -68,21 +67,24 @@ fn relative_to_parent_of_target_dir(original: &Path) -> Result<PathBuf> {
     }
 }
 
-pub(crate) fn out_with_extension(path: &Path, ext: &str) -> Result<PathBuf> {
+pub(crate) fn out_with_extension(
+    path: &Path,
+    ext: &str,
+    target_dir: &TargetDir,
+) -> Result<PathBuf> {
     let mut file_name = path.file_name().unwrap().to_owned();
     file_name.push(ext);
 
     let out_dir = out_dir()?;
-    let rel = relative_to_parent_of_target_dir(path)?;
+    let rel = relative_to_parent_of_target_dir(path, target_dir)?;
     Ok(out_dir.join(rel).with_file_name(file_name))
 }
 
-pub(crate) fn include_dir() -> Result<PathBuf> {
-    let target_dir = target_dir()?;
+pub(crate) fn include_dir(target_dir: &TargetDir) -> Result<PathBuf> {
     Ok(target_dir.join("cxxbridge"))
 }
 
-fn target_dir() -> Result<TargetDir> {
+pub(crate) fn target_dir() -> Result<TargetDir> {
     let fallback_err = match cargo::target_dir() {
         Ok(target_dir) => return Ok(target_dir),
         Err(err) => Error::TargetDir(err),

